; _ArrayDisplaySort.au3
#AutoIt3Wrapper_AU3Check_Parameters= -d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
Func _ArrayDisplaySort(Const ByRef $avArrayF, $sTitle = "Array: ListView Display", $iItemLimit = 0, $iOptions = 0, $sSeparator = "", $sReplace = "")
	#region const
	Local Const $_ARRAYUUCONSTANT_GUI_DOCKBORDERS = 0x66
	Local Const $_ARRAYUUCONSTANT_GUI_DOCKBOTTOM = 0x40
	Local Const $_ARRAYUUCONSTANT_GUI_DOCKHEIGHT = 0x0200
	Local Const $_ARRAYUUCONSTANT_GUI_DOCKLEFT = 0x2
	Local Const $_ARRAYUUCONSTANT_GUI_DOCKRIGHT = 0x4
	Local Const $_ARRAYUUCONSTANT_GUI_EVENT_CLOSE = -3
	Local Const $_ARRAYUUCONSTANT_LVIF_PARAM = 0x4
	Local Const $_ARRAYUUCONSTANT_LVIF_TEXT = 0x1
	Local Const $_ARRAYUUCONSTANT_LVM_GETITEMCOUNT = (0x1000 + 4)
	Local Const $_ARRAYUUCONSTANT_LVM_GETITEMSTATE = (0x1000 + 44)
	Local Const $_ARRAYUUCONSTANT_LVM_INSERTITEMA = (0x1000 + 7)
	Local Const $_ARRAYUUCONSTANT_LVM_SETEXTENDEDLISTVIEWSTYLE = (0x1000 + 54)
	Local Const $_ARRAYUUCONSTANT_LVM_SETITEMA = (0x1000 + 6)
	Local Const $_ARRAYUUCONSTANT_LVS_EX_FULLROWSELECT = 0x20
	Local Const $_ARRAYUUCONSTANT_LVS_EX_GRIDLINES = 0x1
	Local Const $_ARRAYUUCONSTANT_LVS_SHOWSELALWAYS = 0x8
	Local Const $_ARRAYUUCONSTANT_WS_EX_CLIENTEDGE = 0x0200
	Local Const $_ARRAYUUCONSTANT_WS_MAXIMIZEBOX = 0x00010000
	Local Const $_ARRAYUUCONSTANT_WS_MINIMIZEBOX = 0x00020000
	Local Const $_ARRAYUUCONSTANT_WS_SIZEBOX = 0x00040000
	Local Const $_ARRAYUUCONSTANT_tagLVITEM = "int Mask;int Item;int SubItem;int State;int StateMask;ptr Text;int TextMax;int Image;int Param;int Indent;int GroupID;int Columns;ptr pColumns"
	Local Const $LVM_SETCOLUMNWIDTHU = (0x1000 + 30)
	Local Const $LVSCWU_AUTOSIZE = -1
	Local Const $LVSCWU_AUTOSIZE_USEHEADER = -2
	Local $VBScode = 'function SubSort( byref arSingle,iIndex,icase,Sep)'
	$VBScode &= @LF & '	arIndexN=split(iIndex,"|")'
	$VBScode &= @LF & '	dim iAsc:iAsc=0'
	$VBScode &= @LF & '	if arIndexN(0)<0 then iAsc=1'
	$VBScode &= @LF & '	dim arIndex()'
	$VBScode &= @LF & '	redim preserve arIndex(1)'                                                                                                 ;:arIndex(1) =0
	$VBScode &= @LF & '	for a= 0 to ubound(arIndexN)'
	$VBScode &= @LF & '		arIndexN(a)=csng(arIndexN(a))'
	$VBScode &= @LF & '		if arIndexN(a)<>"" and arIndexN(a)<>0 then'
	$VBScode &= @LF & '			redim preserve arIndex(a)'
	$VBScode &= @LF & '			arIndex(a)=abs(arIndexN(a))-1'
	$VBScode &= @LF & '			arIndexN(a)=csng(Iif(arIndexN(a)<0,arIndexN(a)+1,arIndexN(a)-1))'
	$VBScode &= @LF & '		End If'
	$VBScode &= @LF & '	next'
	$VBScode &= @LF & '	ArraySort arSingle, iAsc,  0, UBound(arSingle), arIndex(0),icase,Sep  '                                                                                                 ;SortArray, iAsc,First, Last,iViewColNum
	$VBScode &= @LF & '	for indexcol=1 to ubound(arIndex)'                                                                                                 ;col=2'; start with check on 2nd  index'; define first index as col 1 (in call, 1)
	$VBScode &= @LF & '		SubSort1 arSingle,arIndex,indexcol,iif(arIndexN(indexcol)<0,-1,1),icase,Sep  '                                                                                                 ;->, sort order
	$VBScode &= @LF & '	Next'
	$VBScode &= @LF & '	SubSort=arSingle'
	$VBScode &= @LF & 'end function   '                                                                                                 ;==>ArrayFieldSort
	$VBScode &= @LF & 'function SubSort1(byref arArray,arIndex,indexcol, iAsc,icase,Sep)'
	$VBScode &= @LF & '	dim Row,col:col=arIndex(indexcol)'
	$VBScode &= @LF & '	dim pcol:pcol=arIndex(indexcol-1)'
	$VBScode &= @LF & '	iAsc=Iif(iAsc<0,1,0)'
	$VBScode &= @LF & '	dim arTemp(),itemp,	sMarker:sMarker="Equal"'                                                                                                 ;,sTemp(1)
	$VBScode &= @LF & '	redim preserve arTemp(1) '                                                                                                 ;redim extra row
	$VBScode &= @LF & '	for Row=1 to UBound(arArray) '                                                                                                 ; go through all rows of 2d array in that column to check for dupes
	$VBScode &= @LF & '			arRow=split(arArray(row),Sep)'
	$VBScode &= @LF & '			arRowB4=split(arArray(row-1),Sep)'
	$VBScode &= @LF & '		if indexcol>1 then '                                                                                                 ;check cols in each row first if more than 2 index cols
	$VBScode &= @LF & '			for c=0 to indexcol-1'
	$VBScode &= @LF & '				if lcase(arRow(arIndex(c)))<>lcase(arRowB4(arIndex(c))) Then'
	$VBScode &= @LF & '					sMarker="pColsNotEqual"'
	$VBScode &= @LF & '					c=indexcol'
	$VBScode &= @LF & '				End If'
	$VBScode &= @LF & '			Next'
	$VBScode &= @LF & '		End If'
	$VBScode &= @LF & '		if lcase(arRow(pcol))=lcase(arRowB4(pcol)) and sMarker="Equal" Then '                                                                                                 ;dupes in the prev col.
	$VBScode &= @LF & '			arTemp(itemp)=arArray(row-1)'                                                                                                 ;Array2DToD( arArray2d,"",0,row-1,1) '; set first line of new potential sort array
	$VBScode &= @LF & '			redim preserve arTemp(itemp+1) '                                                                                                 ;redim extra row
	$VBScode &= @LF & '			arTemp(itemp+1)=arArray(row)'                                                                                                 ;Array2DToD( arArray2d,"",0,row-1,1) '; set first line of new potential sort array
	$VBScode &= @LF & '			itemp=itemp+1'
	$VBScode &= @LF & '		Else'
	$VBScode &= @LF & '			sMarker="Equal"'
	$VBScode &= @LF & '			SubSortDo1 arArray,arTemp,itemp,iAsc,col,row,icase'
	$VBScode &= @LF & '		End If'
	$VBScode &= @LF & '	Next'
	$VBScode &= @LF & '	SubSortDo1 arArray,arTemp,itemp,iAsc,col,row,icase'
	$VBScode &= @LF & 'end function   '
	$VBScode &= @LF & 'function SubSortDo1(byref arArray,byref arTemp,byref itemp,iAsc,col,row,icase)'
	$VBScode &= @LF & '	dim sTemp()'
	$VBScode &= @LF & '	if itemp>0 then'
	$VBScode &= @LF & '		ArraySort arTemp,  iAsc,0, UBound(arTemp), col ,icase'                                                                                                 ;sort on current col (pcol+1), asc?
	$VBScode &= @LF & '		for i= 0 to ubound(arTemp)'
	$VBScode &= @LF & '			arArray(row-ubound(arTemp)+i-1)=arTemp(i)'
	$VBScode &= @LF & '		Next'
	$VBScode &= @LF & '	End If'
	$VBScode &= @LF & '	redim preserve arTemp(1)'
	$VBScode &= @LF & '	itemp=0'                                                                                                 ; change backto single, then get into 2d array properly, then go on to check next line'; row=row-1??
	$VBScode &= @LF & '	SubSortDo1= SortArray'
	$VBScode &= @LF & 'end function'
	$VBScode &= @LF & 'Function IIf( expr, truepart, falsepart )'
	$VBScode &= @LF & '   IIf = falsepart'
	$VBScode &= @LF & '   If expr Then IIf = truepart'''
	$VBScode &= @LF & 'End Function'
	$VBScode &= @LF & 'function ArraySort(ByRef SortArray, iAsc,First, Last,iViewColNum,icase,Sep)'
	$VBScode &= @LF & '	dim strWrite,arCol,arColumn()'
	$VBScode &= @LF & '	ReDim Preserve arColumn(ubound(SortArray))'
	$VBScode &= @LF & '	Dim intPointer, booIsNumeric: booIsNumeric = True'
	$VBScode &= @LF & '	For intPointer = First To Last'
	$VBScode &= @LF & '		arCol = Split( SortArray(intPointer), Sep, -1,0 )'
	$VBScode &= @LF & '		If Not IsNumeric( arCol(iViewColNum) ) Then'
	$VBScode &= @LF & '			booIsNumeric = False'
	$VBScode &= @LF & '			Exit For'
	$VBScode &= @LF & '		End If'
	$VBScode &= @LF & '	Next'
	$VBScode &= @LF & '	For intPointer = First To Last'
	$VBScode &= @LF & '		arCol = Split( SortArray(intPointer), Sep, -1,0 )'
	$VBScode &= @LF & '		If booIsNumeric Then'
	$VBScode &= @LF & '			arColumn(intPointer)  = CSng( arCol(iViewColNum) )'
	$VBScode &= @LF & '		else'
	$VBScode &= @LF & '			arColumn(intPointer)  =  arCol(iViewColNum)'
	$VBScode &= @LF & '		End If'
	$VBScode &= @LF & '	Next'
	$VBScode &= @LF & '	if not icase then  QuickSortColumn  SortArray, arColumn,First, Last,iViewColNum'
	$VBScode &= @LF & '	if icase or booIsNumeric then QuickSortColumnCase  SortArray, arColumn,First, Last,iViewColNum'
	$VBScode &= @LF & '	if iasc=1 then ReverseElements SortArray, 0, ubound(SortArray)'
	$VBScode &= @LF & '	ArraySort= SortArray'
	$VBScode &= @LF & 'End function   '
	$VBScode &= @LF & 'function QuickSortColumn(ByRef SortArray, ByRef arColumn, First, Last,iViewColNum)'
	$VBScode &= @LF & '	dim Low,High,collitem,arCol'
	$VBScode &= @LF & '	dim Temp,ListSeparator'
	$VBScode &= @LF & '	Low = First'
	$VBScode &= @LF & '	High = Last'
	$VBScode &= @LF & '	ListSeparator=arColumn((First + Last) / 2)'
	$VBScode &= @LF & '	Do'
	$VBScode &= @LF & '		While lcase(arColumn(Low)) < lcase(ListSeparator)'
	$VBScode &= @LF & '			Low = Low + 1'
	$VBScode &= @LF & '		WEnd'
	$VBScode &= @LF & '		While lcase(arColumn(High)) > lcase(ListSeparator)'
	$VBScode &= @LF & '			High = High - 1'
	$VBScode &= @LF & '		WEnd'
	$VBScode &= @LF & '		If (Low <= High) Then'
	$VBScode &= @LF & '			Temp = SortArray(Low)'
	$VBScode &= @LF & '			SortArray(Low) = SortArray(High)'
	$VBScode &= @LF & '			SortArray(High) = Temp'
	$VBScode &= @LF & '			Temp = arColumn(Low)'
	$VBScode &= @LF & '			arColumn(Low) = arColumn(High)'
	$VBScode &= @LF & '			arColumn(High) = Temp'
	$VBScode &= @LF & '			Low = Low + 1'
	$VBScode &= @LF & '			High = High - 1'
	$VBScode &= @LF & '		End If'
	$VBScode &= @LF & '	Loop While (Low <= High)'
	$VBScode &= @LF & '	If (First < High) Then QuickSortColumn  SortArray, arColumn,First, High,iViewColNum '
	$VBScode &= @LF & '	If (Low < Last) Then QuickSortColumn  SortArray, arColumn,Low, Last,iViewColNum '
	$VBScode &= @LF & 'End function   '
	$VBScode &= @LF & 'function QuickSortColumnCase(ByRef SortArray, ByRef arColumn, First, Last,iViewColNum)'
	$VBScode &= @LF & '	dim Low,High,collitem,arCol'
	$VBScode &= @LF & '	dim Temp,ListSeparator'
	$VBScode &= @LF & '	Low = First'
	$VBScode &= @LF & '	High = Last'
	$VBScode &= @LF & '	ListSeparator=arColumn((First + Last) / 2)'
	$VBScode &= @LF & '	Do'
	$VBScode &= @LF & '		While (arColumn(Low) < ListSeparator)'
	$VBScode &= @LF & '			Low = Low + 1'
	$VBScode &= @LF & '		WEnd'
	$VBScode &= @LF & '		While (arColumn(High) > ListSeparator)'
	$VBScode &= @LF & '			High = High - 1'
	$VBScode &= @LF & '		WEnd'
	$VBScode &= @LF & '		If (Low <= High) Then'
	$VBScode &= @LF & '			Temp = SortArray(Low)'
	$VBScode &= @LF & '			SortArray(Low) = SortArray(High)'
	$VBScode &= @LF & '			SortArray(High) = Temp'
	$VBScode &= @LF & '			Temp = arColumn(Low)'
	$VBScode &= @LF & '			arColumn(Low) = arColumn(High)'
	$VBScode &= @LF & '			arColumn(High) = Temp'
	$VBScode &= @LF & '			Low = Low + 1'
	$VBScode &= @LF & '			High = High - 1'
	$VBScode &= @LF & '		End If'
	$VBScode &= @LF & '	Loop While (Low <= High)'
	$VBScode &= @LF & '	If (First < High) Then QuickSortColumnCase  SortArray, arColumn,First, High,iViewColNum '
	$VBScode &= @LF & '	If (Low < Last) Then QuickSortColumnCase  SortArray, arColumn,Low, Last,iViewColNum '
	$VBScode &= @LF & 'End function   '
	$VBScode &= @LF & 'Sub ReverseElements( arrToReverse, intAlphaRow, intOmegaRow )'
	$VBScode &= @LF & '    Dim intPointer, intUpper, intLower, varHolder'
	$VBScode &= @LF & '    For intPointer = 0 To Int( (intOmegaRow - intAlphaRow) / 2 )'
	$VBScode &= @LF & '        intUpper = intAlphaRow + intPointer'
	$VBScode &= @LF & '        intLower = intOmegaRow - intPointer'
	$VBScode &= @LF & '        varHolder = arrToReverse(intLower)'
	$VBScode &= @LF & '        arrToReverse(intLower) = arrToReverse(intUpper)'
	$VBScode &= @LF & '        arrToReverse(intUpper) = varHolder'
	$VBScode &= @LF & '    Next'
	$VBScode &= @LF & 'End Sub'
	;===========================================avbs code for QuickSort
	Local $VBScode2 = 'function Array2DCreate( byref ar1Strings,Base,Sep)'
	$VBScode2 &= @LF & '	dim r,c,NewUbound,ar2ArrayStrings()'
	$VBScode2 &= @LF & '	For r = Base To ubound(ar1Strings) '
	$VBScode2 &= @LF & '		aRowArray = split(ar1Strings(r),Sep)'
;~ 	$VBScode2 &= @LF & '		aRowArray = split(ar1Strings(r),"' & $sSeparator & '")'
	$VBScode2 &= @LF & '		if ubound(aRowArray)>NewUbound then'
	$VBScode2 &= @LF & '			NewUbound=ubound(aRowArray)'
	$VBScode2 &= @LF & '		end if'
	$VBScode2 &= @LF & '	next'
	$VBScode2 &= @LF & '	ReDim preserve ar2ArrayStrings(NewUbound,ubound(ar1Strings)-base)'
	$VBScode2 &= @LF & '		For r = Base To ubound(ar1Strings)'
	$VBScode2 &= @LF & '		aRowArray = split(ar1Strings(r),Sep)'
	$VBScode2 &= @LF & '			For c = 0 To ubound(aRowArray)'
	$VBScode2 &= @LF & '				ar2ArrayStrings(c,r-base) = aRowArray(c)'
	$VBScode2 &= @LF & '			Next'
	$VBScode2 &= @LF & '		Next'
	$VBScode2 &= @LF & '	Array2DCreate=ar2ArrayStrings'
	$VBScode2 &= @LF & 'End function   '


	#endregion
	Local $i_LISTVIEWPrevcolumn, $ar_LISTVIEWArray[4000], $ar_LISTVIEW[4000], $s_LISTVIEWSortOrder, $sBlank = "";$B_DESCENDING[1], $i_LISTVIEWNumItemsView,
	Local $sSeparator2 = $sSeparator,  $iBuffer = 2048000, $sCol0 = "", $vbs, $vbs2, $avArray, $vTmp, $iNumItems;$sSeparator3,
	Local $timerstamp1 = TimerInit(), $aItem, $i_ColWidth, $i_OrderColumn;, $timerstampprep = TimerInit()
	Local $iTranspose = BitAND($iOptions, 1), $iSort = BitAND($iOptions, 2), $iCase = BitAND($iOptions, 4)
	Local $iDelimited = BitAND($iOptions, 8), $iFast = BitAND($iOptions, 16)
	If Not IsArray($avArrayF) And IsString($avArrayF) Then
		$avArray = StringSplit(StringStripCR($avArrayF), @LF)
		$iDelimited = 1
	Else
		$avArray = $avArrayF
	EndIf
	If Not IsArray($avArray) Then Return SetError(1, 0, 0)
	; Dimension checking
	Local $iDimension = UBound($avArray, 0), $iUBound = UBound($avArray, 1), $iSubItems = UBound($avArray, 2), $arTitle[1], $sTempHeader = 'Row'
	If $iDimension > 2 Then Return SetError(2, 0, 0)
	If $iDelimited And $iDimension > 1 Then $iDelimited = 0
	
	;===========================================added rjc
	$arTitle = StringSplit($sTitle, "|")
	If (UBound($arTitle) > 2 Or $iDelimited) And $iDimension = 1 Then
		$iSubItems = UBound($arTitle)
		$iDelimited = 1
		$ar_LISTVIEWArray = $avArray
	EndIf

	; Separator handling
	If $iDelimited Then $iTranspose = 0
	If $iDelimited Then
		Local $arSeps = StringSplit(",|;", "")
		$iSort = 1
		If $sSeparator = "" Then
			For $i = 1 To UBound($arSeps) - 1
				If StringInStr($avArray[0] & $avArray[1] & $avArray[UBound($avArray) - 1], $arSeps[$i]) Then
					$sSeparator = $arSeps[$i]
					ExitLoop
				EndIf
			Next
		EndIf
		If $iDelimited And $sSeparator <> "" Then $sReplace = $sSeparator
	EndIf
	If $iSort Then
		If $sSeparator = "" Then $sSeparator = ","
		$sReplace = $sSeparator
		$sBlank = " "
		$sSeparator2 = $sBlank & $sSeparator
	EndIf
	If $sSeparator = "" Then
		$sSeparator = Chr(1)
		If $sReplace == "" Then $sReplace = Chr(1); Then $chr = 1
	EndIf
	If $sReplace == "" Then $sReplace = "&"

	;===========================================added rjc
	If $sTitle = -1 Or $sTitle = "" Then $sTitle = "ListView array 1D and 2D Display"
	If StringInStr($sTitle, "|") Then; then check if there are header cols too;
		$arTitle = StringSplit($sTitle, "|")
		$sTitle = StringReplace($arTitle[1], $sSeparator, $sReplace, 0, 1);$arTitle[1]
		If $arTitle[2] = "" Then $sCol0 = "col 0"
		$sTempHeader &= $sSeparator & StringReplace($arTitle[2], $sSeparator, $sReplace, 0, 1) & $sCol0;$arTitle[2]
	Else
		$sTempHeader &= $sSeparator & "Col 0"
	EndIf

	; Separator handling
	If $sSeparator = "" Then
		$sSeparator = Chr(1)
		If $sReplace == "" Then $sReplace = Chr(1); Then $chr = 1
	EndIf
	If $sReplace == "" Then $sReplace = "&"

	;===========================================added rjc
	If $sSeparator <> $sReplace Or $iFast Then
		If $iDimension = 2 Then
			Local $avArray[$iUBound ][$iSubItems ]
			For $i = 0 To $iUBound - 1
				For $j = 0 To $iSubItems - 1
					$avArray[$i][$j] = StringReplace($avArray[$i][$j], $sSeparator, $sReplace, 0, 1);replace seaparator
				Next
			Next
		ElseIf $iDimension = 1 Then
			Local $avArray[$iUBound ]
			For $i = 0 To $iUBound - 1
				$avArray[$i] = StringReplace($avArray[$i], $sSeparator, $sReplace, 0, 1) ;replace seaparator
			Next
		EndIf
	Else
;~ 		$avArray = $avArrayF
		If $iDelimited Then
			$iSubItems = UBound($arTitle)
			$iDelimited = 1
;~ 			Local $ar_LISTVIEWArray = $avArray
			For $i = 0 To $iUBound - 1
				$vTmp = StringLen($avArray[$i])
				If $vTmp > $iBuffer Then $iBuffer = $vTmp
			Next
		EndIf
	EndIf
;~ 	ConsoleWrite("$sSeparator=" & $sSeparator & @LF)
;~ 	ConsoleWrite("$sReplace=" & $sReplace & @LF)
;~ 	ConsoleWrite("$iSort=" & $iSort & @LF)
;~ 	ConsoleWrite("$sTitle=" & $sTitle & @LF)
;~ 	ConsoleWrite("$ar_LISTVIEWArray[0]=" & $ar_LISTVIEWArray[0] & @LF)

;~ 	;===========================================added rjc

	If $iDelimited And $iTranspose = 1 Then
		$iTranspose = 0
		$sTitle = "** WARNING ** no transpose for delimited string array: " & $sTitle
	EndIf

	; Hard limits
	Local $iLVIAddUDFThreshold = 4000, $iColLimit, $iWidth = @DesktopWidth * 2 / 3, $iHeight = @DesktopHeight * 2 / 3;, $sSeparator2 = $sBlank & $sSeparator, $sSeparator3
	If $iItemLimit > 40 Then $iLVIAddUDFThreshold = $iItemLimit
	$iColLimit = $iLVIAddUDFThreshold
	If $iItemLimit = 1 Or $iItemLimit < 0 Or $iItemLimit = Default Then $iItemLimit = $iLVIAddUDFThreshold

	; Declare/define variables
	Local $sHeader = "Row", $ar_2dCurrent[1];, $ar_LISTVIEWArray$i, $j,  $arSelItems,
	Local $iOnEventMode = Opt("GUIOnEventMode", 0), $sDataSeparatorChar = Opt("GUIDataSeparatorChar", $sSeparator)
	
	; Swap dimensions if transposing
	If $iTranspose Then
		Local $iTmp = $iUBound
		$iUBound = $iSubItems
		$iSubItems = $iTmp
	EndIf
	; Set limits for dimensions
	If Not $iUBound Then $iUBound = 1
	If Not $iSubItems Then $iSubItems = 1
	;===========================================added rjc
	If $iSubItems > $iColLimit Then
		$iSubItems = $iColLimit
		$sTitle = "** WARNING ** $iColLimit maximum 4000: " & $sTitle
	EndIf
	;===========================================added rjc
	If $iItemLimit < 1 Then $iItemLimit = $iUBound
	If $iUBound > $iItemLimit Then $iUBound = $iItemLimit
	;===========================================added ult
	If $iLVIAddUDFThreshold > $iUBound - 1 Then $iLVIAddUDFThreshold = $iUBound - 1
	;===========================================added ult

	; Convert array into text for listview
	ReDim $ar_LISTVIEWArray[$iUBound ]
	ReDim $ar_LISTVIEW[$iUBound ]
	Local $iArrayType = $iDimension + 2 * $iTranspose - 1, $sTxt;, $sExec1 = '"', $sExec2 = '"',$avArrayText[$iUBound + 1]

	If Not $iDelimited Then
		For $i = 0 To $iLVIAddUDFThreshold;$iUBound
			$ar_LISTVIEWArray[$i] = "[" & $i & "]"
			Switch $iArrayType   ;   $iDimension + 2 * $iTranspose - 1
				Case 0 ;1D
					For $j = 0 To $iSubItems - 1; Add to text array [$iSubMax]
						$ar_LISTVIEWArray[$i] &= $sSeparator & $avArray[$i];$sSeparator &
					Next
				Case 1 ;2D
					For $j = 0 To $iSubItems - 1; Add to text array
						$ar_LISTVIEWArray[$i] &= $sSeparator & $avArray[$i][$j];$sSeparator &
					Next
				Case 2 ;1DT
					For $j = 0 To $iSubItems - 1; Add to text array
						$ar_LISTVIEWArray[$i] &= $sSeparator & $avArray[$j];$sSeparator &
					Next
				Case 3 ;2DT
					For $j = 0 To $iSubItems - 1; Add to text array
						$ar_LISTVIEWArray[$i] &= $sSeparator & $avArray[$j][$i];$sSeparator &
					Next
			EndSwitch

		Next
		For $i = ($iLVIAddUDFThreshold + 1) To $iUBound - 1
			$vTmp = 0
			Switch $iArrayType   ;   $iDimension + 2 * $iTranspose - 1
				Case 0 ;1D
					For $j = 0 To $iSubItems - 1; Add to text array [$iSubMax]
						$vTmp += StringLen($avArray[$i])
					Next
				Case 1 ;2D
					For $j = 0 To $iSubItems - 1; Add to text array
						$vTmp += StringLen($avArray[$i][$j])
					Next
				Case 2 ;1DT
					For $j = 0 To $iSubItems - 1; Add to text array
						$vTmp += StringLen($avArray[$j])
					Next
				Case 3 ;2DT
					For $j = 0 To $iSubItems - 1; Add to text array
						$vTmp += StringLen($avArray[$j][$i])
					Next
			EndSwitch
			If $vTmp > $iBuffer Then $iBuffer = $vTmp
		Next
	Else ;$iDelimited
		For $i = ($iLVIAddUDFThreshold + 1) To $iUBound - 1
			$vTmp = 0
			Switch $iArrayType   ;   $iDimension + 2 * $iTranspose - 1
				Case 0 ;1D
					$vTmp = StringLen($avArray[$i])
				Case 1 ;2D
					$vTmp = StringLen($avArray[$i][$j])
				Case 2 ;1DT
					$vTmp = StringLen($avArray[$j])
				Case 3 ;2DT
					$vTmp = StringLen($avArray[$j][$i])
			EndSwitch
			If $vTmp > $iBuffer Then $iBuffer = $vTmp
		Next
	EndIf
	$iBuffer += 1

	; Set header up;; make LV header
	;===========================================added rjc
	Local $uboundary = $iSubItems - 1, $iMaxPipes, $FirstPipes = @extended, $sStrRep
	StringReplace($ar_LISTVIEWArray[0], $sSeparator, $sSeparator)
	If $iDelimited Then
		For $i = 0 To UBound($ar_LISTVIEWArray) - 1
			StringReplace($ar_LISTVIEWArray[$i], $sSeparator, $sSeparator)
			If @extended > $iMaxPipes Then $iMaxPipes = @extended
		Next
		$uboundary = $iMaxPipes
		$iSubItems = $uboundary + 1
		If $iMaxPipes > $FirstPipes Then
			For $i = 1 To $iMaxPipes - $FirstPipes
				$sStrRep &= " " & $sSeparator & " "
			Next
		EndIf
	EndIf
	;===========================================added rjc
	If Not $iDelimited And $iDimension = 1 And Not $iTranspose Then $uboundary = 0
	If $uboundary > $iColLimit - 1 Then $uboundary = $iColLimit - 1
	For $i = 1 To $uboundary
		If $i < UBound($arTitle) - 2 Then
;~ 			$sTempHeader &= $sSeparator & $arTitle[$i + 2];arTitle[$i + 2]
			$sTempHeader &= $sSeparator & StringReplace($arTitle[$i + 2], $sSeparator, $sBlank & $sReplace, 0, 1);arTitle[$i + 2]
		Else
			$sTempHeader &= $sSeparator & "Col " & $i
		EndIf
	Next
	$sHeader = $sTempHeader & $sBlank
;~ 	ConsoleWrite("$sHeader=" & $sHeader & @LF)
;~ 	ConsoleWrite("$uboundary=" & $uboundary & @LF)
;~ 	ConsoleWrite("$iSubItems=" & $iSubItems & @LF)
;~ 	ConsoleWrite("$ar_LISTVIEWArray[0]=" & $ar_LISTVIEWArray[0] & @LF)

	;===========================================
	Local $iAddMask = BitOR($_ARRAYUUCONSTANT_LVIF_TEXT, $_ARRAYUUCONSTANT_LVIF_PARAM)
	Local $tBuffer = DllStructCreate("char Text[" & $iBuffer & "]"), $pBuffer = DllStructGetPtr($tBuffer)
	Local $tItem = DllStructCreate($_ARRAYUUCONSTANT_tagLVITEM), $pItem = DllStructGetPtr($tItem)
	DllStructSetData($tItem, "Param", 0)
	DllStructSetData($tItem, "Text", $pBuffer)
	DllStructSetData($tItem, "TextMax", $iBuffer)

	; Set interface up
	Local $hGUI = GUICreate($sTitle, $iWidth, $iHeight, Default, Default, BitOR($_ARRAYUUCONSTANT_WS_SIZEBOX, $_ARRAYUUCONSTANT_WS_MINIMIZEBOX, $_ARRAYUUCONSTANT_WS_MAXIMIZEBOX))
	Local $aiGUISize = WinGetClientSize($hGUI), $timerstampsort1, $timerstampsort2
	Local $hListView = GUICtrlCreateListView($sHeader, 0, 0, $aiGUISize[0], $aiGUISize[1] - 26, $_ARRAYUUCONSTANT_LVS_SHOWSELALWAYS)
	Local $hCopy = GUICtrlCreateButton("Copy Selected", 3, $aiGUISize[1] - 23, $aiGUISize[0] - 6, 20)

	GUICtrlSetResizing($hListView, $_ARRAYUUCONSTANT_GUI_DOCKBORDERS)
	GUICtrlSetResizing($hCopy, $_ARRAYUUCONSTANT_GUI_DOCKLEFT + $_ARRAYUUCONSTANT_GUI_DOCKRIGHT + $_ARRAYUUCONSTANT_GUI_DOCKBOTTOM + $_ARRAYUUCONSTANT_GUI_DOCKHEIGHT)
	GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_SETEXTENDEDLISTVIEWSTYLE, $_ARRAYUUCONSTANT_LVS_EX_GRIDLINES, $_ARRAYUUCONSTANT_LVS_EX_GRIDLINES)
	GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_SETEXTENDEDLISTVIEWSTYLE, $_ARRAYUUCONSTANT_LVS_EX_FULLROWSELECT, $_ARRAYUUCONSTANT_LVS_EX_FULLROWSELECT)
	GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_SETEXTENDEDLISTVIEWSTYLE, $_ARRAYUUCONSTANT_WS_EX_CLIENTEDGE, $_ARRAYUUCONSTANT_WS_EX_CLIENTEDGE)

	; Fill listview
	If $iDelimited Then
		For $i = 0 To $iLVIAddUDFThreshold
			$ar_LISTVIEW[$i] = GUICtrlCreateListViewItem("[" & $i & "]" & $sSeparator & $ar_LISTVIEWArray[$i], $hListView) & $sStrRep
		Next
	Else
		For $i = 0 To $iLVIAddUDFThreshold
			$ar_LISTVIEW[$i] = GUICtrlCreateListViewItem($ar_LISTVIEWArray[$i], $hListView)
		Next
	EndIf
	If $iDimension = 1 Then $iNumItems = 2
	If $iDimension = 2 Then $iNumItems = UBound($avArray, 2 - $iTranspose) + 1
	If $iDelimited Then  ; so 1D delim strings
		For $i = ($iLVIAddUDFThreshold + 1) To $iUBound - 1
			$aItem = StringSplit($ar_LISTVIEWArray[$i], $sSeparator)
			DllStructSetData($tBuffer, "Text", "[" & $i & "]")

			; Add listview item
			DllStructSetData($tItem, "Item", $i)
			DllStructSetData($tItem, "SubItem", 0)
			DllStructSetData($tItem, "Mask", $iAddMask)
			GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_INSERTITEMA, 0, $pItem)

			; Set listview subitem text
			DllStructSetData($tItem, "Mask", $_ARRAYUUCONSTANT_LVIF_TEXT)
			For $j = 1 To $aItem[0]
				DllStructSetData($tBuffer, "Text", $aItem[$j])
				DllStructSetData($tItem, "SubItem", $j)
				GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_SETITEMA, 0, $pItem)
			Next
		Next
	ElseIf ($iLVIAddUDFThreshold + 1) <= $iUBound - 1 Then
		For $i = ($iLVIAddUDFThreshold + 1) To $iUBound - 1
			DllStructSetData($tBuffer, "Text", "[" & $i & "]")

			; Add listview item
			DllStructSetData($tItem, "Item", $i)
			DllStructSetData($tItem, "SubItem", 0)
			DllStructSetData($tItem, "Mask", $iAddMask)
			GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_INSERTITEMA, 0, $pItem)

			; Set listview subitem text
			DllStructSetData($tItem, "Mask", $_ARRAYUUCONSTANT_LVIF_TEXT)
			For $j = 2 - $iDimension To $iNumItems - $iDimension
				Switch $iArrayType   ;   $iDimension + 2 * $iTranspose - 1
					Case 0 ;1D
						$sTxt = $avArray[$i];$sSeparator &
					Case 1 ;2D
						$sTxt = $avArray[$i][$j];$sSeparator &
					Case 2 ;1DT
						$sTxt = $avArray[$j];$sSeparator &
					Case 3 ;2DT
						$sTxt = $avArray[$j][$i];$sSeparator &
				EndSwitch
				DllStructSetData($tBuffer, "Text", $sTxt)
				DllStructSetData($tItem, "SubItem", $j - 1 + $iDimension)
				GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_SETITEMA, 0, $pItem)
			Next
		Next
	EndIf
	; Set Column widths
	;===========================================added rjc         ; ensure column width narrow enough to avoid crash with many columns
	If $iSubItems > 100 Then    ; GUICtrlCreateListViewItem can only display listview columns to
		$i_ColWidth = Int(20 / (1 + Int($iSubItems / @DesktopWidth)))   ;a certain number of pixels on the header
		For $i = 1 To $iSubItems - 1    ;, so colwidth needs to be set/ shrunk if too many??
			GUICtrlSendMsg($hListView, $LVM_SETCOLUMNWIDTHU, $i, $i_ColWidth)
		Next
	EndIf
	GUICtrlSendMsg($hListView, $LVM_SETCOLUMNWIDTHU, 1, $LVSCWU_AUTOSIZE)
	DllCall("user32.dll", "lparam", "SendMessage", "hwnd", $hListView, "int", $LVM_SETCOLUMNWIDTHU, "wparam", 1, "lparam", $LVSCWU_AUTOSIZE);Local $aResult = 
	If $iUBound < 100 Then GUICtrlSendMsg($hListView, $LVM_SETCOLUMNWIDTHU, 0, 45)
	If $iUBound >= 100 Then GUICtrlSendMsg($hListView, $LVM_SETCOLUMNWIDTHU, 0, $LVSCWU_AUTOSIZE)
	GUICtrlSendMsg($hListView, $LVM_SETCOLUMNWIDTHU, $iSubItems - 1, $LVSCWU_AUTOSIZE_USEHEADER)
	;===========================================added rjc
	; Show dialog
	GUISetState(@SW_SHOW, $hGUI)
	ConsoleWrite($sTitle & " Mine2 Time=" & Round(TimerDiff($timerstamp1)) & "" & @TAB & " msec" & @LF)
	;===========================================avbs code for QuickSort
	While 1
		Switch GUIGetMsg()
			Case $_ARRAYUUCONSTANT_GUI_EVENT_CLOSE
				ExitLoop

			Case $hListView
;~ 				ConsoleWrite(" $hListView $iSubItems=" & $iSubItems & @LF)
				If ($iUBound > 500000) Or ($iDimension = 1 And UBound($arTitle) < 3 And $iTranspose) Then
					$sTitle = "** WARNING ** No sort; see HelpFile: " & $sTitle
					WinSetTitle($hGUI, "", $sTitle)
					ContinueLoop
				EndIf
				Local $timerstampS = TimerInit()
				If $s_LISTVIEWSortOrder == "" Then;And $sBlank <> ""
					If $iDelimited Then;And $iDimension = 2
						For $i = 0 To ($iUBound - 1)
							$ar_LISTVIEWArray[$i] = "[" & $i & "]" & $sSeparator & StringReplace($ar_LISTVIEWArray[$i], $sSeparator, " " & $sSeparator, 0, 1) & $sStrRep;$sBlank
						Next
					Else
						For $i = ($iLVIAddUDFThreshold + 1) To ($iUBound - 1)
							$ar_LISTVIEWArray[$i] = "[" & $i & "]" & $sSeparator
							For $j = 0 To $iSubItems - 1
								Switch $iArrayType   ;   $iDimension + 2 * $iTranspose - 1
									Case 0 ;1D
										For $j = 0 To $iSubItems - 1; Add to text array [$iSubMax]
											$ar_LISTVIEWArray[$i] &= $avArray[$i] & $sSeparator2;$sSeparator &
										Next
									Case 1 ;2D
										For $j = 0 To $iSubItems - 1; Add to text array
											$ar_LISTVIEWArray[$i] &= $avArray[$i][$j] & $sSeparator2;$sSeparator &
										Next
									Case 2 ;1DT
										For $j = 0 To $iSubItems - 1; Add to text array
											$ar_LISTVIEWArray[$i] &= $avArray[$j] & $sSeparator2;$sSeparator &
										Next
									Case 3 ;2DT
										For $j = 0 To $iSubItems - 1; Add to text array
											$ar_LISTVIEWArray[$i] &= $avArray[$j][$i] & $sSeparator2;$sSeparator &
										Next
								EndSwitch
								$ar_LISTVIEWArray[$i] &= $sSeparator2
							Next
							$ar_LISTVIEWArray[$i] &= $sBlank
						Next
					EndIf
					If $vbs2 == "" Then
						$vbs2 = ObjCreate("ScriptControl")
						$vbs2.language = "vbscript"
						$vbs2.addcode($VBScode2)
					EndIf
					$ar_2dCurrent = $vbs2.Run("Array2DCreate", $ar_LISTVIEWArray, 0, $sSeparator)
					Local $arAr[UBound($ar_2dCurrent, 2) + 1], $arAr2[UBound($ar_2dCurrent, 2) + 1]
					$arAr[0] = $ar_LISTVIEWArray
					$arAr2[0] = $ar_2dCurrent
					$iSubItems = UBound($ar_2dCurrent, 2)
				EndIf
				Local $timeS = Round(TimerDiff($timerstampS))
				$i_OrderColumn = GUICtrlGetState($hListView)
;~ 				ConsoleWrite("$i_OrderColumn=" & $i_OrderColumn & @LF & "$iSubItems=" & $iSubItems & @LF)
				If $i_OrderColumn >= $iSubItems Then ContinueLoop
				Local  $timerstampsort, $timerstamp,  $s_UBound;$szIconFile, $s_Blank = " ",$ar_Size, , $s_DataItem, $s_Trim,$ar_Orig,
				If $i_LISTVIEWPrevcolumn <> $i_OrderColumn Then $s_LISTVIEWSortOrder = "DESC"
				If $i_LISTVIEWPrevcolumn = $i_OrderColumn And $s_LISTVIEWSortOrder == "DESC"  Then ; Reverse it DESC
					$timerstamp = TimerInit()
					$s_UBound = UBound($ar_LISTVIEWArray)
					For $a = 0 To $iLVIAddUDFThreshold
						GUICtrlSetData($ar_LISTVIEW[$a], $ar_LISTVIEWArray[$s_UBound - $a - 1])
					Next
					For $a = ($iLVIAddUDFThreshold + 1) To (UBound($ar_LISTVIEWArray) - 1)
						DllStructSetData($tItem, "Item", $a)
						DllStructSetData($tItem, "Mask", $_ARRAYUUCONSTANT_LVIF_TEXT);~ 						; Set listview subitem text
						For $j = 0 To $iSubItems - 1
							DllStructSetData($tBuffer, "Text", $ar_2dCurrent[$s_UBound - $a - 1][$j])
							DllStructSetData($tItem, "SubItem", $j)
							GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_SETITEMA, 0, $pItem)
						Next
					Next
					ConsoleWrite("aft _ArrayRev DESC :" & TimerDiff($timerstamp) & " msecs" & @LF)
					GUICtrlSendMsg($hListView, $LVM_SETCOLUMNWIDTHU, $i_OrderColumn, $LVSCWU_AUTOSIZE)
				Else
					$timerstampsort2 = TimerInit()
					If ($i_LISTVIEWPrevcolumn <> $i_OrderColumn Or Not $s_LISTVIEWSortOrder) And _
							(Not IsArray($arAr[$i_OrderColumn]) Or Not IsArray($arAr2[$i_OrderColumn])) _
							And $i_OrderColumn Then
						GUICtrlSendMsg($hListView, $LVM_SETCOLUMNWIDTHU, $i_OrderColumn, $LVSCWU_AUTOSIZE)
;~ 						Local  $EmptyLine, $First = 0, $Last = UBound($ar_LISTVIEWArray) - 1;,,; $szFile$Line1, $s_ListHeader, 
						$timerstampsort1 = TimerInit()
						$timerstampsort = TimerInit()
						If $i_OrderColumn = 0 Then ;_ArrayRev($ar_LISTVIEWArray, 0)
							local $iEnd = UBound($ar_LISTVIEWArray) - 1
							For $i = 0 To Int((0 + $iEnd - 1) / 2)
								$vTmp = $ar_LISTVIEWArray[$i]
								$ar_LISTVIEWArray[$i] = $ar_LISTVIEWArray[$iEnd]
								$ar_LISTVIEWArray[$iEnd] = $vTmp
								$iEnd -= 1
							Next
						EndIf
						ConsoleWrite("aft _ArrayRev :" & TimerDiff($timerstampsort) & " msecs" & @LF)
;~ 						Local $timerstampsort3 = TimerInit()
;~ 						_ArraySort($ar_2dCurrent,1,0,0,UBound($ar_2dCurrent,2),$i_OrderColumn)
;~  						ConsoleWrite("aft _ArraySort :" & TimerDiff($timerstampsort3) & " msecs" & @LF)
;~ 						_ArrayDisplay($ar_2dCurrent, " after _ArraySort")
;~ ;;====================================================================================
						If $vbs == "" Then
;~ 							Local $timerstampA = TimerInit()
							$vbs = ObjCreate("ScriptControl")
							$vbs.language = "vbscript"
							$vbs.addcode($VBScode)
						EndIf
						;;~ 						_ArrayDisplay($ar_LISTVIEWArray, " B4 SubSort")
						$ar_LISTVIEWArray = $vbs.Run("SubSort", $ar_LISTVIEWArray, $i_OrderColumn + 1, $iCase, $sSeparator)
						;;~ 						_ArrayDisplay($ar_LISTVIEWArray, " after SubSort")
						If UBound($ar_LISTVIEWArray) > $iLVIAddUDFThreshold Then
							If $vbs2 == "" Then
								$vbs2 = ObjCreate("ScriptControl")
								$vbs2.language = "vbscript"
								$vbs2.addcode($VBScode2)
							EndIf
							$ar_2dCurrent = $vbs2.Run("Array2DCreate", $ar_LISTVIEWArray, 0, $sSeparator)
;~ ;							_ArrayDisplay($ar_2dCurrent, " after Array2DCreate")
						EndIf
;~ ;====================================================================================
						$arAr[$i_OrderColumn] = $ar_LISTVIEWArray
						$arAr2[$i_OrderColumn] = $ar_2dCurrent
					ElseIf ($i_LISTVIEWPrevcolumn <> $i_OrderColumn Or Not $s_LISTVIEWSortOrder) Or $i_OrderColumn = 0 Then
						$ar_LISTVIEWArray = $arAr[$i_OrderColumn]
						$ar_2dCurrent = $arAr2[$i_OrderColumn]
					EndIf
					For $a = 0 To $iLVIAddUDFThreshold
						GUICtrlSetData($ar_LISTVIEW[$a], $ar_LISTVIEWArray[$a])
					Next
					For $a = ($iLVIAddUDFThreshold + 1) To (UBound($ar_LISTVIEWArray) - 1)
						DllStructSetData($tItem, "Item", $a)
						DllStructSetData($tItem, "Mask", $_ARRAYUUCONSTANT_LVIF_TEXT);~ 						; Set listview subitem text
						For $j = 0 To $iSubItems - 1
							DllStructSetData($tBuffer, "Text", $ar_2dCurrent[$a][$j])
							DllStructSetData($tItem, "SubItem", $j)
							GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_SETITEMA, 0, $pItem)
						Next
					Next
					$i_LISTVIEWPrevcolumn = $i_OrderColumn
					$s_LISTVIEWSortOrder = "ASC"
					If $timerstampsort1 Then
						ConsoleWrite("aFT  _Quick_SortColumns Total:" & TimerDiff($timerstampsort1) + $timeS & " msecs" & @LF)
						$timerstampsort1 = 0
					Else
						ConsoleWrite("aft _ArrayRev ASC :" & TimerDiff($timerstampsort2) + $timeS & " msecs" & @LF)
					EndIf
					GUICtrlSendMsg($hListView, $LVM_SETCOLUMNWIDTHU, $i_OrderColumn, $LVSCWU_AUTOSIZE)
				EndIf
				GUISetState()

				If $s_LISTVIEWSortOrder == "ASC"  Then
					$s_LISTVIEWSortOrder = "DESC"
				Else
					$s_LISTVIEWSortOrder = "ASC"
				EndIf
				Local $Cursor_ARROW
				GUISetState(@SW_UNLOCK)
				GUISetCursor($Cursor_ARROW, 1);~
			Case $hCopy
				Local $sClip = ""

				; Get selected indices [ _GUICtrlListView_GetSelectedIndices($hListView, True) ]
				Local $aiCurItems[1] = [0]
				For $i = 0 To GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_GETITEMCOUNT, 0, 0)
					If GUICtrlSendMsg($hListView, $_ARRAYUUCONSTANT_LVM_GETITEMSTATE, $i, 0x2) Then
						$aiCurItems[0] += 1
						ReDim $aiCurItems[$aiCurItems[0] + 1]
						$aiCurItems[$aiCurItems[0]] = $i
					EndIf
				Next

				; Generate clipboard text
				If Not $aiCurItems[0] Then
					For $i = 0 To $iUBound - 1
						$sClip &= $ar_LISTVIEWArray[$i] & @CRLF
					Next
				Else
					For $i = 1 To UBound($aiCurItems) - 1
						$sClip &= $ar_LISTVIEWArray[$aiCurItems[$i]] & @CRLF
					Next
				EndIf
				ClipPut($sClip)
		EndSwitch
	WEnd
	$vbs = ""
	$vbs2 = ""
	GUIDelete($hGUI)
	$arAr = ""
	$ar_LISTVIEWArray = ""
	$ar_2dCurrent = ""
	Opt("GUIOnEventMode", $iOnEventMode)
	Opt("GUIDataSeparatorChar", $sDataSeparatorChar)

	Return 1
EndFunc   ;==>_ArrayDisplaySort